Update.
[platform/upstream/glibc.git] / glibcbug.in
1 #! /bin/sh
2 #
3 # glibcbug - create a bug report and mail it to the bug address.
4 #
5 # configuration section:
6 #       these variables are filled in by configure
7 #
8 VERSION="@VERSION@"
9 BUGGLIBC="bugs@gnu.org"
10 ADDONS="@subdirs@"
11 HOST="@host@"
12 CC='@CC@'
13 CFLAGS="@CFLAGS@"
14 VERSIONING="@VERSIONING@"
15 BUILD_STATIC="@static@"
16 BUILD_SHARED="@shared@"
17 BUILD_PIC_DEFAULT="@pic_default@"
18 BUILD_PROFILE="@profile@"
19 BUILD_OMITFP="@omitfp@"
20 BUILD_BOUNDED="@bounded@"
21 BUILD_STATIC_NSS="@static_nss@"
22 STDIO="@stdio@"
23
24 PATH=/bin:/usr/bin:/usr/local/bin:$PATH
25 export PATH
26
27 TEMP=`mktemp -q /tmp/glibcbugXXXXXX 2>/dev/null`
28 if test $? -ne 0; then
29   TEMP=/tmp/glibcbug.$$
30   echo > $TEMP
31   chmod 600 $TEMP
32 fi
33 TEMPx=`mktemp -q /tmp/glibcbugXXXXXX 2>/dev/null`
34 if test $? -ne 0; then
35   TEMPx=/tmp/glibcbug.$$.x
36   echo > $TEMPx
37   chmod 600 $TEMPx
38 fi
39
40 BUGADDR=${1-$BUGGLIBC}
41
42 : ${EDITOR=emacs}
43
44 : ${USER=${LOGNAME-`whoami`}}
45
46 trap 'rm -f $TEMP $TEMPx; exit 1' 1 2 3 13 15
47 trap 'rm -f $TEMP $TEMPx' 0
48
49
50 # How to read the passwd database.
51 PASSWD="cat /etc/passwd"
52
53 if [ -f /usr/lib/sendmail ] ; then
54         MAIL_AGENT="/usr/lib/sendmail -oi -t"
55 elif [ -f /usr/sbin/sendmail ] ; then
56         MAIL_AGENT="/usr/sbin/sendmail -oi -t"
57 else
58         MAIL_AGENT=rmail
59 fi
60
61 # Figure out how to echo a string without a trailing newline
62 N=`echo 'hi there\c'`
63 case "$N" in
64 *c)     ECHON1='echo -n' ECHON2= ;;
65 *)      ECHON1=echo ECHON2='\c' ;;
66 esac
67
68 # Find out the name of the originator of this PR.
69 if [ -n "$NAME" ]; then
70   ORIGINATOR="$NAME"
71 elif [ -f $HOME/.fullname ]; then
72   ORIGINATOR="`sed -e '1q' $HOME/.fullname`"
73 else
74   # Must use temp file due to incompatibilities in quoting behavior
75   # and to protect shell metacharacters in the expansion of $LOGNAME
76   $PASSWD | grep "^$LOGNAME:" | awk -F: '{print $5}' | sed -e 's/,.*//' > $TEMP
77   ORIGINATOR="`cat $TEMP`"
78 fi
79
80 if [ -n "$ORGANIZATION" ]; then
81   if [ -f "$ORGANIZATION" ]; then
82     ORGANIZATION="`cat $ORGANIZATION`"
83   fi
84 else
85   if [ -f $HOME/.organization ]; then
86     ORGANIZATION="`cat $HOME/.organization`"
87   elif [ -f $HOME/.signature ]; then
88     ORGANIZATION=`sed -e "s/^/  /" $HOME/.signature; echo ">"`
89   fi
90 fi
91
92 # If they don't have a preferred editor set, then use
93 if [ -z "$VISUAL" ]; then
94   if [ -z "$EDITOR" ]; then
95     EDIT=vi
96   else
97     EDIT="$EDITOR"
98   fi
99 else
100   EDIT="$VISUAL"
101 fi
102
103 # Find out some information.
104 SYSTEM=`( [ -f /bin/uname ] && /bin/uname -a ) || \
105         ( [ -f /usr/bin/uname ] && /usr/bin/uname -a ) || echo ""`
106 ARCH=`[ -f /bin/arch ] && /bin/arch`
107 MACHINE=`[ -f /bin/machine ] && /bin/machine`
108 CCVERSION=`$CC -v 2>&1 | sed -n 's/gcc version //p'`
109
110 ORGANIZATION_C='<organization of PR author (multiple lines)>'
111 SYNOPSIS_C='<synopsis of the problem (one line)>'
112 SEVERITY_C='<[ non-critical | serious | critical ] (one line)>'
113 PRIORITY_C='<[ low | medium | high ] (one line)>'
114 CLASS_C='<[ sw-bug | doc-bug | change-request | support ] (one line)>'
115 RELEASE_C='<release number or tag (one line)>'
116 ENVIRONMENT_C='<machine, os, target, libraries (multiple lines)>'
117 DESCRIPTION_C='<precise description of the problem (multiple lines)>'
118 HOW_TO_REPEAT_C='<code/input/activities to reproduce the problem (multiple lines)>'
119 FIX_C='<how to correct or work around the problem, if known (multiple lines)>'
120
121
122 cat > $TEMP <<EOF
123 SEND-PR: -*- send-pr -*-
124 SEND-PR: Lines starting with \`SEND-PR' will be removed automatically, as
125 SEND-PR: will all comments (text enclosed in \`<' and \`>').
126 SEND-PR:
127 From: ${USER}
128 To: ${BUGADDR}
129 Subject: [50 character or so descriptive subject here (for reference)]
130
131 >Submitter-Id:  net
132 >Originator:    ${ORIGINATOR}
133 >Organization:
134 ${ORGANIZATION- $ORGANIZATION_C}
135 >Confidential:  no
136 >Synopsis:      $SYNOPSIS_C
137 >Severity:      $SEVERITY_C
138 >Priority:      $PRIORITY_C
139 >Category:      libc
140 >Class:         $CLASS_C
141 >Release:       libc-${VERSION}
142 >Environment:
143         $ENVIRONMENT_C
144 `[ -n "$HOST" ] && echo Host type: $HOST`
145 `[ -n "$SYSTEM" ] && echo System: $SYSTEM`
146 `[ -n "$ARCH" ] && echo Architecture: $ARCH`
147 `[ -n "$MACHINE" ] && echo Machine: $MACHINE`
148 `[ -n "$ADDONS" ] && echo Addons: $ADDONS`
149 `[ -n "$CFLAGS" ] && echo Build CFLAGS: $CFLAGS`
150 `[ -n "$CC" ] && echo Build CC: $CC`
151 `[ -n "$CCVERSION" ] && echo Compiler version: $CCVERSION`
152 `[ -n "$VERSIONING" ] && echo Symbol versioning: $VERSIONING`
153 `[ -n "$BUILD_STATIC" ] && echo Build static: $BUILD_STATIC`
154 `[ -n "$BUILD_SHARED" ] && echo Build shared: $BUILD_SHARED`
155 `[ -n "$BUILD_PIC_DEFAULT" ] && echo Build pic-default: $BUILD_PIC_DEFAULT`
156 `[ -n "$BUILD_PROFILE" ] && echo Build profile: $BUILD_PROFILE`
157 `[ -n "$BUILD_OMITFP" ] && echo Build omitfp: $BUILD_OMITFP`
158 `[ -n "$BUILD_BOUNDED" ] && echo Build bounded: $BUILD_BOUNDED`
159 `[ -n "$BUILD_STATIC_NSS" ] && echo Build static-nss: $BUILD_STATIC_NSS`
160 `[ -n "$STDIO" ] && echo Stdio: $STDIO`
161
162 >Description:
163         $DESCRIPTION_C
164 >How-To-Repeat:
165         $HOW_TO_REPEAT_C
166 >Fix:
167         $FIX_C
168 EOF
169
170 chmod u+w $TEMP
171 cp $TEMP $TEMPx
172
173 eval $EDIT $TEMP
174
175 if cmp -s $TEMP $TEMPx; then
176         echo "File not changed, no bug report submitted."
177         exit 1
178 fi
179
180 #\f
181 #       Check the enumeration fields
182
183 # This is a "sed-subroutine" with one keyword parameter
184 # (with workaround for Sun sed bug)
185 #
186 SED_CMD='
187 /$PATTERN/{
188 s|||
189 s|<.*>||
190 s|^[    ]*||
191 s|[     ]*$||
192 p
193 q
194 }'
195
196
197 while :; do
198   CNT=0
199
200   #
201   # 1) Severity
202   #
203   PATTERN=">Severity:"
204   SEVERITY=`eval sed -n -e "\"$SED_CMD\"" $TEMP`
205   case "$SEVERITY" in
206     ""|non-critical|serious|critical) CNT=`expr $CNT + 1` ;;
207     *)  echo "$COMMAND: \`$SEVERITY' is not a valid value for \`Severity'."
208   esac
209   #
210   # 2) Priority
211   #
212   PATTERN=">Priority:"
213   PRIORITY=`eval sed -n -e "\"$SED_CMD\"" $TEMP`
214   case "$PRIORITY" in
215     ""|low|medium|high) CNT=`expr $CNT + 1` ;;
216     *)  echo "$COMMAND: \`$PRIORITY' is not a valid value for \`Priority'."
217   esac
218   #
219   # 3) Class
220   #
221   PATTERN=">Class:"
222   CLASS=`eval sed -n -e "\"$SED_CMD\"" $TEMP`
223   case "$CLASS" in
224     ""|sw-bug|doc-bug|change-request|support) CNT=`expr $CNT + 1` ;;
225     *)  echo "$COMMAND: \`$CLASS' is not a valid value for \`Class'."
226   esac
227
228   [ $CNT -lt 3 ] &&
229     echo "Errors were found with the problem report."
230
231   while :; do
232     $ECHON1 "a)bort, e)dit or s)end? $ECHON2"
233     read input
234     case "$input" in
235       a*)
236         echo "$COMMAND: problem report saved in $HOME/dead.glibcbug."
237         cat $TEMP >> $HOME/dead.glibcbug
238         xs=1; exit
239         ;;
240       e*)
241         eval $EDIT $TEMP
242         continue 2
243         ;;
244       s*)
245         break 2
246         ;;
247     esac
248   done
249 done
250 #
251 #       Remove comments and send the problem report
252 #       (we have to use patterns, where the comment contains regex chars)
253 #
254 # /^>Originator:/s;$ORIGINATOR;;
255 sed  -e "
256 /^SEND-PR:/d
257 /^>Organization:/,/^>[A-Za-z-]*:/s;$ORGANIZATION_C;;
258 /^>Confidential:/s;<.*>;;
259 /^>Synopsis:/s;$SYNOPSIS_C;;
260 /^>Severity:/s;<.*>;;
261 /^>Priority:/s;<.*>;;
262 /^>Class:/s;<.*>;;
263 /^>Release:/,/^>[A-Za-z-]*:/s;$RELEASE_C;;
264 /^>Environment:/,/^>[A-Za-z-]*:/s;$ENVIRONMENT_C;;
265 /^>Description:/,/^>[A-Za-z-]*:/s;$DESCRIPTION_C;;
266 /^>How-To-Repeat:/,/^>[A-Za-z-]*:/s;$HOW_TO_REPEAT_C;;
267 /^>Fix:/,/^>[A-Za-z-]*:/s;$FIX_C;;
268 " $TEMP > $TEMPx
269
270 if $MAIL_AGENT < $TEMPx; then
271   echo "$COMMAND: problem report sent"
272   xs=0; exit
273 else
274   echo "$COMMAND: mysterious mail failure, report not sent."
275   echo "$COMMAND: problem report saved in $HOME/dead.glibcbug."
276   cat $TEMP >> $HOME/dead.glibcbug
277 fi
278
279 exit 0